{ Qwrites - QwriteV, Qwrite, QwriteC, QwriteCV              ver 1.3, 11-10-86 }
{ These four procedures do fast screen writes and automatically configure to
  your machine for Mono, CGA, and EGA.  They also has the feature of leaving
  the attribute alone by setting Attr<0; then they will just overwrite the
  display using the current attributes.  The upper left column is 1,1.
  You MUST read MODIFICATIONS in QWIK13.DOC for any changes in this file!     }


type Str80 = string[80];

{ QwriteV - Quick screen write, untyped VAR parameter       ver 1.3, 11-10-86 }
procedure QwriteV (Row, Col: byte; Attr: integer; VAR St);
begin
Inline(
   $1E                   {       PUSH  DS               ;Save Turbo's DS}
  /$C5/$76/<ST           {       LDS   SI,[BP+<St]      ;Place offset in SI}
  /$FC                   {       CLD                    ;Set DF to increment}
  /$AD                   {       LODSW                  ;Load St[1],St[0]}
  /$31/$C9               {       XOR   CX,CX            ;Set CX=0}
  /$8E/$C1               {       MOV   ES,CX            ;Set ES=0}
  /$00/$C1               {       ADD   CL,AL            ;Save length in CL}
  /$74/$0F               {       JZ    Exit1            ;Null string}
  /$8A/$76/<ROW          {       MOV   DH,[BP+<Row]     ;Move row (Row*256)}
  /$8B/$7E/<COL          {       MOV   DI,[BP+<Col]     ;Move col}
  /$4F                   {       DEC   DI               ;Convert to 0-79 range}
  /$D1/$E7               {       SHL   DI,1             ;Mult by 2}
  /$8B/$5E/<ATTR         {       MOV   BX,[BP+<Attr]    ;Move attr}
  /$E8/$47/$00           {       CALL  NEAR Qdisp       ;Call Qdisp, address}
                         {                              ; is pre-compiled!}
  /$1F                   {Exit1: POP   DS               ;Restore Turbo's DS}
);
end;

{ Qwrite - Quick screen write, value parameter              ver 1.3, 11-10-86 }
procedure Qwrite (Row, Col: byte; Attr: integer; St: Str80);
begin
Inline(
   $1E                   {       PUSH  DS               ;Save Turbo's DS}
  /$8D/$B6/>ST           {       LEA   SI,[BP+>St]      ;Place offset in SI}
  /$8C/$D2               {       MOV   DX,SS            ;Move SS into DS for}
  /$8E/$DA               {       MOV   DS,DX            ;  use by LODS}
  /$FC                   {       CLD                    ;Set DF to increment}
  /$AD                   {       LODSW                  ;Load St[1],St[0]}
  /$31/$C9               {       XOR   CX,CX            ;Set CX=0}
  /$8E/$C1               {       MOV   ES,CX            ;Set ES=0}
  /$00/$C1               {       ADD   CL,AL            ;Save length in CL}
  /$74/$12               {       JZ    Exit2            ;Null string}
  /$8A/$B6/>ROW          {       MOV   DH,[BP+>Row]     ;Move row (Row*256)}
  /$8B/$BE/>COL          {       MOV   DI,[BP+>Col]     ;Move col}
  /$4F                   {       DEC   DI               ;Convert to 0-79 range}
  /$D1/$E7               {       SHL   DI,1             ;Mult by 2}
  /$8B/$9E/>ATTR         {       MOV   BX,[BP+>Attr]    ;Move attr}
  /$E8/$11/$00           {       CALL  NEAR Qdisp       ;Call Qdisp, address}
                         {                              ; is pre-compiled!}
  /$1F                   {Exit2: POP   DS               ;Restore Turbo's DS}
);
end;

{ QwritesDisp - Subroutine for all QwriteXX procedures      ver 1.3, 11-10-86 }
procedure QwritesDisp;
begin
Inline(
   $88/$EA               {Qdisp: MOV   DL,CH            ;Set DL=0}
  /$D1/$EA               {       SHR   DX,1             ;(Row*128)}
  /$01/$D7               {       ADD   DI,DX            ;Add (Row*128) in DI}
  /$D1/$EA               {       SHR   DX,1             ;(Row*64)}
  /$D1/$EA               {       SHR   DX,1             ;(Row*32)}
  /$01/$D7               {       ADD   DI,DX            ;Dest offset in DI}
  /$88/$E0               {       MOV   AL,AH            ;Move St[1] to AL}
  /$26/$80/$3E/$49/$04/$07{      ES: CMP BY[$0449],$07  ;Check video mode}
  /$75/$39               {       JNE   Color            ;  use Color routine}
                         {                              ;}
  /$BA/$F6/$AF           {       MOV   DX,$AFF6         ;Addr for Mono}
  /$8E/$C2               {       MOV   ES,DX            ;ES:DI dest pointer}
  /$84/$FF               {EGA:   TEST  BH,BH            ;If Attr<0 ...}
  /$78/$18               {       JS    Mono1            ;  use char only}
                         {                              ;}
                         {; -- Mono routine; Attr, Char and No Wait--}
  /$88/$DC               {       MOV   AH,BL            ;Copy attr to AH}
  /$41                   {Mono2: INC   CX               ;Bump CX for odd char}
  /$D1/$E9               {       SHR   CX,1             ;Divide counter by 2}
                         {                              ; CF=0 if odd length}
  /$EB/$08               {       JMP   SHORT Mon2b      ;Jump into mono loop}
                         {                              ;}
  /$AD                   {Mon2a: LODSW                  ;Load TWO char}
  /$88/$E7               {       MOV   BH,AH            ;Move Ch2 to BH}
  /$88/$DC               {       MOV   AH,BL            ;Copy attr to AH}
  /$AB                   {       STOSW                  ;To dest & inc DI 2}
  /$88/$F8               {       MOV   AL,BH            ;Move Ch2 to AL}
  /$AB                   {Mon2b: STOSW                  ;To dest & inc DI 2}
  /$E2/$F5               {       LOOP  Mon2a            ;Loop until CX=0}
  /$73/$7C               {       JNC   Done             ;Exit if odd length}
  /$AC                   {       LODSB                  ;Load last char}
  /$AB                   {       STOSW                  ;To dest & inc DI 2}
  /$EB/$78               {       JMP   SHORT Done       ;Done}
                         {                              ;}
                         {; -- Mono routine; Char Only and No Wait--}
  /$41                   {Mono1: INC   CX               ;Bump CX for odd char}
  /$89/$CA               {       MOV   DX,CX            ;Save CX in DX}
  /$D1/$E9               {       SHR   CX,1             ;Divide counter by 2}
  /$EB/$05               {       JMP   SHORT Mon1b      ;Jump into mono loop}
                         {                              ;}
  /$AD                   {Mon1a: LODSW                  ;Load TWO char}
  /$AA                   {       STOSB                  ;To dest & inc DI 1}
  /$47                   {       INC   DI               ;Pass up attr}
  /$88/$E0               {       MOV   AL,AH            ;Move Ch2 to AL}
  /$AA                   {Mon1b: STOSB                  ;To dest & inc DI 1}
  /$47                   {       INC   DI               ;Pass up attr}
  /$E2/$F7               {       LOOP  Mon1a            ;Loop until CX=0}
  /$D1/$EA               {       SHR   DX,1             ;Divide counter by 2}
                         {                              ;CF=0 if odd length}
  /$73/$64               {       JNC   Done             ;Exit if odd length}
  /$AC                   {       LODSB                  ;Load last char}
  /$AA                   {       STOSB                  ;To dest & inc DI 1}
  /$EB/$60               {       JMP   SHORT Done       ;Done}
                         {                              ;}
  /$8E/$46/$FC           {Color: MOV   ES,[BP-$04]      ;Copy DS in ES}
  /$26/$80/$3E/>TOEGA/$00{       ES: CMP BY[>ToEGA],$00 ;Check for EGA}
  /$BA/$F6/$B7           {       MOV   DX,$B7F6         ;Addr for Color}
  /$8E/$C2               {       MOV   ES,DX            ;ES:DI dest pointer}
  /$75/$BC               {       JNE   EGA              ;If EGA, do Mono}
  /$BA/$DA/$03           {       MOV   DX,$03DA         ;CGA port}
  /$84/$FF               {       TEST  BH,BH            ;If Attr<0 ...}
  /$78/$29               {       JS    Col1b            ;  use char only}
  /$88/$DC               {       MOV   AH,BL            ;Move attr in AH}
  /$EB/$01               {       JMP   SHORT Col2b      ;Attr and char}
                         {                              ;}
                         {; -- Color routine; Attr, Char and Wait --}
  /$AC                   {Col2a: LODSB                  ;Load source char}
  /$88/$C7               {Col2b: MOV   BH,AL            ;Save char in BH}
  /$FA                   {       CLI                    ;Disable interrupts}
  /$EC                   {E4in2: IN    AL,DX            ;Check CGA status}
  /$A8/$08               {       TEST  AL,$08           ;If #3 bit clear ...}
  /$74/$09               {       JZ    Col2c            ;  skip tests}
  /$88/$F8               {       MOV   AL,BH            ;Move char back in AL}
  /$80/$F9/$90           {       CMP   CL,$90           ;If <145 Cols left,}
  /$78/$A7               {       JS    Mono2            ;  do mono instead}
  /$EB/$0B               {       JMP   SHORT Col2d      ;  else store direct}
  /$D0/$D8               {Col2c: RCR   AL,1             ;If #0 bit set ...}
  /$72/$EE               {       JC    E4in2            ;  try again for $E4}
  /$EC                   {E5in2: IN    AL,DX            ;Check CGA status}
  /$D0/$D8               {       RCR   AL,1             ;If #0 bit clear ...}
  /$73/$FB               {       JNC   E5in2            ;  try again for $E5}
  /$88/$F8               {       MOV   AL,BH            ;Move char back in AL}
  /$AB                   {Col2d: STOSW                  ;Put in dest & inc DI}
  /$FB                   {       STI                    ;Enable interrupts}
  /$E2/$DF               {       LOOP  Col2a            ;Loop till CX=0}
  /$EB/$22               {       JMP   SHORT Done       ;Done}
                         {                              ;}
                         {; -- Color routine; Char only and Wait --}
  /$AC                   {Col1a: LODSB                  ;Load source char}
  /$47                   {       INC   DI               ;Pass up attr}
  /$88/$C7               {Col1b: MOV   BH,AL            ;Save char in BH}
  /$FA                   {       CLI                    ;Disable interrupts}
  /$EC                   {E4in1: IN    AL,DX            ;Check CGA status}
  /$A8/$08               {       TEST  AL,$08           ;If #3 bit clear ...}
  /$74/$09               {       JZ    Col1c            ;  skip tests}
  /$88/$F8               {       MOV   AL,BH            ;Move char back in AL}
  /$80/$F9/$80           {       CMP   CL,$80           ;If <129 Cols left,}
  /$78/$99               {       JS    Mono1            ;  do mono instead.}
  /$EB/$0B               {       JMP   SHORT Col1d      ;  else store direct}
  /$D0/$D8               {Col1c: RCR   AL,1             ;If #0 bit set ...}
  /$72/$EE               {       JC    E4in1            ;  try again for $E4}
  /$EC                   {E5in1: IN    AL,DX            ;Check CGA status}
  /$D0/$D8               {       RCR   AL,1             ;If #0 bit clear ...}
  /$73/$FB               {       JNC   E5in1            ;  try again for $E5}
  /$88/$F8               {       MOV   AL,BH            ;Move char back in AL}
  /$AA                   {Col1d: STOSB                  ;Put in dest & inc DI}
  /$FB                   {       STI                    ;Enable interrupts}
  /$E2/$DE               {       LOOP  Col1a            ;Loop till CX=0}
                         {                              ;}
  /$C3                   {Done:  RET                    ;Return to call}
);
end;

{ QwriteC - Quick screen write, self-centering, value param:   v1.3, 11-10-86 }
procedure QwriteC (Row, ColL, ColR: byte; Attr: integer; St: Str80);
begin
Inline(
   $1E                   {       PUSH  DS               ;Save Turbo's DS}
  /$8D/$B6/>ST           {       LEA   SI,[BP+>St]      ;Place offset in SI}
  /$8C/$D2               {       MOV   DX,SS            ;Move SS into DS for}
  /$8E/$DA               {       MOV   DS,DX            ;  use by LODS}
  /$FC                   {       CLD                    ;Set DF to increment}
  /$AD                   {       LODSW                  ;Load St[1],St[0]}
  /$31/$C9               {       XOR   CX,CX            ;Set CX=0}
  /$8E/$C1               {       MOV   ES,CX            ;Set ES=0}
  /$00/$C1               {       ADD   CL,AL            ;Save length in CL}
  /$74/$1A               {       JZ    Exit3            ;Null string}
  /$8A/$B6/>ROW          {       MOV   DH,[BP+>Row]     ;Move row (Row*256)}
  /$8B/$BE/>COLL         {       MOV   DI,[BP+>ColL]    ;Move col}
  /$03/$BE/>COLR         {       ADD   DI,[BP+>ColR]    ;Add right col}
  /$4F                   {       DEC   DI               ;Convert to 0-79 range}
  /$29/$CF               {       SUB   DI,CX            ;Offset calc'd in DI}
  /$81/$E7/$FE/$FF       {       AND   DI,$FFFE         ;Make even}
  /$8B/$9E/>ATTR         {       MOV   BX,[BP+>Attr]    ;Move attr}
  /$E8/$15/$FF           {       CALL  NEAR Qdisp       ;Call Qdisp, address}
                         {                              ; is pre-compiled!}
  /$1F                   {Exit3: POP   DS               ;Restore Turbo's DS}
);
end;

{ QwriteCV - Quick screen write, self-centering, untyped VAR parameter
                                                            ver 1.3, 11-10-86 }
procedure QwriteCV (Row, ColL, ColR: byte; Attr: integer; VAR St);
begin
Inline(
   $1E                   {       PUSH  DS               ;Save Turbo's DS}
  /$C5/$76/<ST           {       LDS   SI,[BP+<St]      ;Place offset in SI}
  /$FC                   {       CLD                    ;Set DF to increment}
  /$AD                   {       LODSW                  ;Load St[1],St[0]}
  /$31/$C9               {       XOR   CX,CX            ;Set CX=0}
  /$8E/$C1               {       MOV   ES,CX            ;Set ES=0}
  /$00/$C1               {       ADD   CL,AL            ;Save length in CL}
  /$74/$16               {       JZ    Exit4            ;Null string}
  /$8A/$76/<ROW          {       MOV   DH,[BP+<Row]     ;Move row (Row*256)}
  /$8B/$7E/<COLL         {       MOV   DI,[BP+<ColL]    ;Move col}
  /$03/$7E/<COLR         {       ADD   DI,[BP+<ColR]    ;Add right col}
  /$4F                   {       DEC   DI               ;Convert to 0-79 range}
  /$29/$CF               {       SUB   DI,CX            ;Offset calc'd in DI}
  /$81/$E7/$FE/$FF       {       AND   DI,$FFFE         ;Make even}
  /$8B/$5E/<ATTR         {       MOV   BX,[BP+<Attr]    ;Move attr}
  /$E8/$E0/$FE           {       CALL  NEAR Qdisp       ;Call Qdisp, address}
                         {                              ; is pre-compiled!}
  /$1F                   {Exit4: POP   DS               ;Restore Turbo's DS}
);
end;